var express = require('express');
var router = express.Router();

const { getUserAccounts, getUserId } = require('../lib/getUser')
const { getStreamsNew } = require('../routes/getStreams')
const { decryptPassword } = require('../lib/password')

/* POST postUser page. */
router.get('/', async function (req, res, next) {
    let userId = await getUserId(req.auth.user)
    let data = await getUserAccounts(userId)
    for (let index = 0; index < data.length; index++) {
        let element = data[index];
        element.password = await decryptPassword(element.password)
    }

    res.send(data)
});

router.get('/count', async function (req, res, next) {
    try {
        let data = await getUserAccounts(await getUserId(req.auth.user))
        res.json({ "streamCount": data.length })
    } catch (error) {
        res.sendStatus(500)
    }
});

router.get('/streams', async function (req, res, next) {
    try {
        let data = await getStreamsNew()
        res.json(data)
    } catch (error) {
        res.sendStatus(500)
    }
});


module.exports = router;
